program Algoritmo2_13;
(*
 * Algoritmo 2.13. Calculo del salario neto de un trabajador (version 3)
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 2. Secuenciacion y analisis de casos
 *)

uses crt;

const
	HORA_NORMAL = 10;
        HORA_EXTRA = 12;
        UMBRAL_HORAS_EXTRAS = 140;
	IMPUESTO_BAJO = 0.16;
	IMPUESTO_ALTO = 0.22;
        UMBRAL_SUELDO = 1300;
	COMPLEMENTO_QUINQUENIO = 60;
	COMPLEMENTO_ANYO = 6;
var
	numeroHoras : word;     (* dato, horas trabajadas en un mes por el empleado id *)
	id : word;		(* dato, identificador del empleado *)
        antiguedad : word;	(* dato, anyos en la empresa *)
        salarioNeto : real;	(* resultado, salario percibido por el trabajador *)
        salarioBase : word;
        salarioBruto : word;
        descuentos : real;

procedure CalcularSalarioBruto;
(* PRE  numeroHoras y antiguedad tienen un valor *)
(* POST  salarioBruto contiene el salario bruto del trabajador *)

var
   numeroQuinquenios : word;
   numeroAnyos : word;
   pagoQuinquenios : word;
   pagoAnyos : word;

begin
(* calcular sueldo base por horas trabajadas *)
     if numeroHoras > UMBRAL_HORAS_EXTRAS
        then salarioBase := (numeroHoras - UMBRAL_HORAS_EXTRAS) * HORA_EXTRA
                            + UMBRAL_HORAS_EXTRAS * HORA_NORMAL
	else salarioBase := numeroHoras * HORA_NORMAL;

     (* calcular gratificacion por antiguedad *)
     numeroQuinquenios := antiguedad DIV 5;
     numeroAnyos := antiguedad MOD 5;
     pagoQuinquenios := numeroQuinquenios * COMPLEMENTO_QUINQUENIO;
     pagoAnyos := numeroAnyos *  COMPLEMENTO_ANYO;

     (* calcular salario bruto *)
     salarioBruto := salarioBase + pagoQuinquenios + pagoAnyos
end;

procedure CalcularDescuentos;
	  (* PRE  salarioBruto almacena el salario bruto calculado *)
          (* POST  descuentos almacena el valor total de los descuentos sobre el salario bruto *)

begin
     if salarioBruto > UMBRAL_SUELDO
        then descuentos :=  salarioBruto * IMPUESTO_ALTO
        else descuentos := salarioBruto * IMPUESTO_BAJO
end;

procedure CalcularSalarioNeto;
    (* PRE  salarioBruto y descuentos almacenan, respectivamente, el salario bruto y el
               descuento correspondiente *)
    (* POST  salarioNeto contiene el salario percibido por el trabajador,
                 salarioNeto = salarioBruto  descuentos *)

begin
     salarioNeto := salarioBruto - descuentos
end;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 2.13. Calculo del salario neto de *****');
     writeln('*****                 un trabajador (version 3)   *****');
     writeln('*****');
     writeln;
     write('Identificador del empleado: ');
     readln(id);
     write('Numero de horas trabajadas en un mes por el empleado: ');
     readln(numeroHoras);
     write('Antiguedad del empleado: ');
     readln(antiguedad);
     CalcularSalarioBruto;
     CalcularDescuentos;
     CalcularSalarioNeto;
     writeln('El salario del empleado ', id, ' es: ', salarioNeto:1:2);
     writeln;
     write('Pulse enter para continuar');
     readln
end.
