program Algoritmo2_3;
(*
 * Algoritmo 2.3. Calculo del salario neto de un trabajador (version 1)
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 2. Secuenciacion y analisis de casos
 *)

uses crt;
const
     IMPUESTO = 0.20;
     SEGURO_MEDICO = 0.05;
     COMPLEMENTO_QUINQUENIO = 60;
     COMPLEMENTO_ANYO = 6;

var
   salarioBase : longint;  (* dato, sueldo base del trabajador *)
   antiguedad : word;	   (* dato, anyos en la empresa *)
   salarioNeto : real;	   (* resultado, salario percibido por el trabajador *)
   salarioBruto : longint; (* salario bruto del trabajador *)
   descuentos : real; 	   (* descuentos aplicados *)

procedure CalcularSalarioBruto;
(* PRE  salarioBase y antiguedad tienen un valor valido *)
(* POST  salarioBruto contiene el salario bruto del trabajador *)
   var
      numeroQuinquenios : word;
      numeroAnyos : word;
      pagoQuinquenios : word;
      pagoAyos : word;

   begin
        numeroQuinquenios := antiguedad div 5;
        numeroAnyos := antiguedad mod 5;
	pagoQuinquenios := numeroQuinquenios * COMPLEMENTO_QUINQUENIO;
	pagoAyos := numeroAnyos * COMPLEMENTO_ANYO;
	salarioBruto := salarioBase + pagoQuinquenios + pagoAyos
   end;

procedure CalcularDescuentos;
(* PRE  se ha calculado el salario bruto y se ha asignado a salarioBruto *)
(* POST  descuentos almacena el valor total de los descuentos sobre el salario bruto *)

   begin
        descuentos := salarioBruto * (IMPUESTO + SEGURO_MEDICO)
   end;

procedure CalcularSalarioNeto;
(* PRE  salarioBruto y descuentos almacenan, respectivamente, el salario bruto y el
        descuento que le corresponde *)
(* POST  salarioNeto contiene el salario recibido por el trabajador,
         salarioNeto = salarioBruto - descuentos *)

   begin
        salarioNeto := salarioBruto - descuentos
   end;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 2.3. Calculo del salario neto de un *****');
     writeln('*****                trabajador (version 1)         *****');
     writeln('*****');
     writeln;
     write('Introduzca el salario base: ');
     readln(salarioBase);
     write('Introduzca la antiguedad: ');
     readln(antiguedad);
     CalcularSalarioBruto;
     CalcularDescuentos;
     CalcularSalarioNeto;
     writeln('El sueldo neto es: ', salarioNeto:1:2);
     writeln;
     write('Pulse enter para continuar');
     readln
end.
