program Algoritmo3_10;
(*
 * Algoritmo 3.10. Calcular la suma de dos duraciones de tiempo (version 2)
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 3. Acciones y funciones
 *)

uses crt;

(*$R+*) (* Habilita la comprobacion de intervalos *)
(*$Q+*) (* Habilita la comprobacion de desbordamiento (solo en version 7.0) *)

type
    Duracion = record
                     hora : longint;
                     min, seg : 0..59
    end;
var
   t1, t2 : Duracion; (* entrada de datos *)
   t3 : Duracion; (* salida de datos *)

procedure SumarDuraciones(a, b : Duracion; var res : Duracion);
(* Las funciones SumarDuraciones y ConvertirSD del Algoritmo 3.10
  se codifican mediante un procedimiento con un parametro paso por
  referencia, porque en Pascal una funcion no puede devolver un
  valor de un tipo registro *)
  function ConvertirDS(d : Duracion) : longint;
  begin
       ConvertirDS := 3600 * d.hora + 60 * d.min + d.seg
  end;
  procedure ConvertirSD(n : longint; var res : Duracion);
  var
     d : Duracion;
     rh : 0..3599;
  begin
       d.hora := n div 3600;
       rh := n mod 3600;
       d.min := rh div 60;
       d.seg := rh mod 60;
       res := d
  end;

begin  (* de SumarDuraciones *)
     ConvertirSD(ConvertirDS(a) + ConvertirDS(b), res);
end;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 3.10. Calcular la suma de dos          *****');
     writeln('*****                 duraciones de tiempo (version 2) *****');
     writeln('*****');
     writeln;

     writeln('Introduzca dos duraciones:');
     writeln;
     write('  Horas de la duracion 1: ');
     readln(t1.hora);
     write('  Minutos de la duracion 1: ');
     readln(t1.min);
     write('  Segundos de la duracion 1: ');
     readln(t1.seg);
     writeln;
     write('  Horas de la duracion 2: ');
     readln(t2.hora);
     write('  Minutos de la duracion 2: ');
     readln(t2.min);
     write('  Segundos de la duracion 2: ');
     readln(t2.seg);

     SumarDuraciones(t1, t2, t3);

     writeln;
     writeln('La suma de las duraciones es: ',
             t3.hora, '-', t3.min, '-', t3.seg);
     writeln;
     write('Pulse enter para continuar');
     readln
end.

