program Algoritmo3_9;
(*
 * Algoritmo 3.9. Calcular la suma de dos duraciones de tiempo (version 1)
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 3. Acciones y funciones
 *)

uses crt;

(*$R+*) (* Habilita la comprobacion de intervalos *)
{(*$Q+*)  Habilita la comprobacion de desbordamiento (solo en version 7.0)}

type
    Duracion = record
                     hora : longint;
                     min, seg : 0..59
    end;
var
   t1, t2 : Duracion; (* entrada de datos *)
   t3 : Duracion; (* salida de datos *)

procedure SumarDuraciones(d1, d2 : Duracion; var res : Duracion);
(* La funcion SumarDuraciones mostrada en el libro se codifica
  mediante un procedimiento con un parametro paso por referencia,
  porque en Pascal una funcion no puede devolver un valor de un
  tipo registro *)
var
   x, y : 0..1;
begin
     y := (d1.seg + d2.seg) div 60;	(* acarreo de segundos *)
     x := (d1.min + d2.min + y) div 60;	(* acarreo de minutos *)
     res.hora := d1.hora + d2.hora + x;
     res.min := (d1.min + d2.min + y) mod 60;
     res.seg := (d1.seg + d2.seg) mod 60;
end;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 3.9. Calcular la suma de dos          *****');
     writeln('*****                duraciones de tiempo (version 1) *****');
     writeln('*****');
     writeln;
     writeln('Introduzca dos duraciones:');
     writeln;
     write('  Horas de la duracion 1: ');
     readln(t1.hora);
     write('  Minutos de la duracion 1: ');
     readln(t1.min);
     write('  Segundos de la duracion 1: ');
     readln(t1.seg);
     writeln;
     write('  Horas de la duracion 2: ');
     readln(t2.hora);
     write('  Minutos de la duracion 2: ');
     readln(t2.min);
     write('  Segundos de la duracion 2: ');
     readln(t2.seg);

     SumarDuraciones(t1, t2, t3);

     writeln;
     writeln('La suma de las duraciones es: ',
             t3.hora, '-', t3.min, '-', t3.seg);
     writeln;
     write('Pulse enter para continuar');
     readln
end.

