program Algoritmo5_11;
(*
 * Algoritmo 5.11. Obtener el k-abecedario de mayor longitud
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 5. Tecnicas de disenyo de algoritmos
 * Fichero de entrada: dat5_11.txt
 *)

(* El codigo ASCII de la enye no se encuentra entre el codigo ASCII *)
(* de la letra 'n' y la letra 'o'                                   *)

uses crt, unitmsc1;

type
    TKAbecedario = record
                         long : integer;
                         primeraLetra : char
    end;

var
   kABC : TKAbecedario;
   EsUltimokABC, EsVaciakABC : boolean;
   anterior : char;
   mayorkABC : TKAbecedario;
   i : integer;
   S : msc1;

procedure EncontrarInikABC;
          (* PRE  EA es el primer caracter de la secuencia o
                  el siguiente despues del ultimo
                  k-abecedario en Piz, si lo hay *)
          (* POST  EA es la segunda letra del siguiente k-abecedario,
                   si lo hay *)
begin
     repeat
           anterior := EA_MSC1(S);
           Avanzar_MSC1(S);
     (* INV  No hay ningun k-abecedario entre EA y
             el ultimo k-abecedario en Piz, si lo hay *)
     until (EA_MSC1(S) = MSC1_MarcaFin) or (EA_MSC1(S) = Succ(anterior));
     EsUltimokABC := EA_MSC1(S) = MSC1_MarcaFin
end;

procedure IniciarkABC;
          (* POST  Se actualizan EsVaciakABC y EsUltimokABC,
                   y anterior y EA contienen el primer y el segundo caracter,
                   respectivamente del primer k-abecedario, si lo hay *)
begin
     Comenzar_MSC1(S);
     if EA_MSC1(S) = MSC1_MarcaFin then begin
                                             EsUltimokABC := true;
                                             EsVaciakABC := true;
     end
     else begin
               EncontrarInikABC;
               EsVaciakABC := EA_MSC1(S) = MSC1_MarcaFin;
     end;
end;

procedure AvanzarkABC;
          (* PRE  EsUltimokABC = Falso y EA es el segundo caracter
                 del actual k-abecedario *)
          (* POST  kABC contiene la longitud y el primer caracter del actual
                  k-abecedario, EA es el segundo caracter del siguiente
                  k-abecedario, si lo hay, y se actualiza EsUltimokABC *)
begin
     kABC.long := 1;
     kABC.primeraLetra := anterior;
     REPEAT
           kABC.long := kABC.long + 1;
       	   anterior := EA_MSC1(S);
       	   Avanzar_MSC1(S);
     (* INV  kABC.long mantiene la longitud del k-abecedario actual *)
     until (EA_MSC1(S) = MSC1_MarcaFin) or (EA_MSC1(S) <> Succ(anterior));
     if (EA_MSC1(S) = MSC1_MarcaFin) then EsUltimokABC := true
     else EncontrarInikABC
end;

begin
     TratamientoInicial_MSC1(S);
     Cargar_fichero_MSC1(S,'dat5_11.txt');
     clrscr;
     writeln;
     writeln ('*****');
     writeln ('***** Algoritmo 5.11  Obtener el k-abecedario de mayor longitud');
     writeln ('*****');
     writeln;
     write('La secuencia de entrada es: ');
     Comenzar_MSC1 (S);
     while (EA_MSC1 (S) <> MSC1_MarcaFin) do begin
                write(EA_MSC1(S));
       		Avanzar_MSC1 (S)
     end;
     writeln;
     IniciarkABC;
     if EsVaciakABC then write('No hay k-abecedarios')
     else begin
         AvanzarkABC;
         mayorkABC := kABC;
         while not EsUltimokABC do begin
               AvanzarkABC;
               if mayorkABC.long < kABC.long then mayorkABC := kABC
         (* INV  mayorkABC.long mantiene la longitud del maximo
                k-abecedario de Piz *)
         end;
         writeln;
         writeln('El k-abecedario de mayor longitud es: ');
         writeln;
         writeln('   longitud: ', mayorkABC.long);
         writeln;
         write('   k-abecedario: ');
         for i := 1 to mayorkABC.long do
             write(chr(ord(mayorkABC.primeraletra)+i-1));
      end;
      writeln;
      writeln;
      write('Pulse enter para continuar');
      readln
end.
