program Algoritmo5_3;
(*
 * Algoritmo 5.3. Calcular el numero de pares (tercer modelo, segundo esquema)
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 5. Tecnicas de disenyo de algoritmos
 * Fichero de entrada: datos5_3.txt
 *)

uses crt, unitmse1;

var
    a, b : integer;
    numA, numB : integer;
    numPares : integer;
    S : mse1;

(*
 * Maquina abstracta del tercer modelo a partir de
 * una maquina secuencial del primer modelo
 *)
   aux : integer;
procedure TratamientoInicial_MSE3(VAR S : mse1);
begin
     TratamientoInicial_MSE1(S);
end;

procedure Comenzar_MSE3(VAR S : mse1);
begin
     Comenzar_MSE1(S);
     aux := EA_MSE1 (S);
     Avanzar_MSE1(S);
end;

procedure Avanzar_MSE3(VAR S : mse1);
begin
     aux := EA_MSE1 (S);
     Avanzar_MSE1(S);
end;

function EA_MSE3(VAR S : mse1) : integer;
begin
     EA_MSE3 := aux;
end;

procedure Cargar_Fichero_MSE3(var S : mse1; nombre : string);
begin
     Cargar_Fichero_MSE1(S, nombre);
end;

function EsVacia_MSE3(S : mse1) : boolean;
begin
     EsVacia_MSE3 := EA_MSE1(S) = MSE1_MarcaFin;
end;

function EsUltimo_MSE3(S : mse1) : boolean;
begin
     EsUltimo_MSE3 := EA_MSE1(S) = MSE1_MarcaFin
end;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 5.3. Calcular el numero de pares      *****');
     writeln('*****                (tercer modelo, segundo esquema) *****');
     writeln('*****');
     writeln;
     writeln('Introduzca un par de enteros distintos:');
     write('   primer entero: ');
     readln(a);
     write('   segundo entero: ');
     readln(b);
     writeln;
     write('La secuencia de entrada es: ');
     TratamientoInicial_MSE3(s);
     Cargar_fichero_MSE3(S,'datos5_3.txt');
     Comenzar_MSE3(S);
     if EsVacia_MSE3(S) then write('Secuencia vacia')
     else begin
               numPares := 0;
  	       numA := 0;
	       numB := 0;
               (* Se utiliza la equivalencia ITERAR-MIENTRAS *)
               if EA_MSE3(S) = a then begin
                                 numPares := numPares + numB;
                                 numA := numA + 1
               end
               else if EA_MSE3(S) = b then begin
                                      numPares := numPares + numA;
                                      numB := numB + 1
               end;
               write(EA_MSE3(S), ' ');
               while not EsUltimo_MSE3(S) do begin
                     Avanzar_MSE3(S);
                     write(EA_MSE3(S), ' ');
                     if EA_MSE3(S) = a then begin
                                       numPares := numPares + numB;
                                       numA := numA + 1
                     end
                     else if EA_MSE3(S) = b then begin
                                            numPares := numPares + numA;
                                            numB := numB + 1
                     end;
               end;
               writeln;
               writeln;
               writeln('El numero de pares (', a,', ', b, '), (', b, ', ', a, ') es: ', numPares);
     end;
     writeln;
     write('Pulse enter para continuar');
     readln
end.
