program Algoritmo6_17;
(*
 * Algoritmo 6.17. Cifrado PlayFair
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 6. Tablas
 * Fichero de entrada: dat6_17.txt
 *)

uses crt, unitmsc1;
const
     N = 5;
     ESPACIO = ' ';
type
    Palabra = string;
    MatrizCar = array [1..N,1..N] of char;
    ParLetras = record
                      p, s : Char;
                end;
    Posicion = record
                     f, c : integer;
               end;
var
   clave : Palabra;			(* palabra clave *)
   parCifrado : ParLetras;              (* par codificado *)
   mc : MatrizCar;			(* matriz de codificacion *)
   S : msc1;				(* texto original *)
   R : msc1;				(* texto cifrado  *)
(* lexico de una secuencia intermedia de pares de caracteres *)
   parActual : ParLetras;
   ultimoPar : boolean;

function FinPares : Boolean;
begin
     FinPares := (EA_MSC1(S) = MSC1_MarcaFin) and not ultimoPar
end;

procedure IgnorarBlancos;
(* Salta blancos del texto original *)
begin
     while EA_MSC1(S) = ESPACIO do
           Avanzar_MSC1(S);
end;

procedure sustituir(var l : char);
begin
     case l of
          'j': l:='i';
          '': l:='n';
     end;
end;

procedure SigPar;
begin
               IgnorarBlancos;
               if EA_MSC1(S) <> MSC1_MarcaFin then begin
                  parActual.p := EA_MSC1(S);
                  sustituir(parActual.p);
                  Avanzar_MSC1(S);
                  IgnorarBlancos;
                  if EA_MSC1(S) = MSC1_MarcaFin then begin
                                                          ultimoPar := true;
                                                          parActual.s:='x';
                  end
                  else begin
                            parActual.s := EA_MSC1(S);
                            sustituir(parActual.s);
                            if parActual.s=parActual.p then
                               parActual.s:='x'
                            end;
                  end;
end;

procedure ComenzarPar;

begin
     Comenzar_MSC1(S);
     ultimoPar := false;
     Sigpar;
end;

procedure AvanzarPar;
begin
     if ultimoPar then ultimoPar := false
     else begin
               Avanzar_MSC1(S);
               SigPar;
     end;
end;

function CarEnPalabra(p : Palabra; long : integer; c : Char) : Boolean;
(* PRE:  long > 0 *)
(* POST  retorna Verdadero si el caracter c se encuentra en la tabla p,
         Falso en otro caso *)
var
   i : 1..N+1;          (* En el rango [1, long] *)

begin
     i := 1;
     while (i <> long+1) and not (p[i] = c) do
           i := i + 1;
     CarEnPalabra := i <> long+1;
end;

procedure CrearMatrizCodificacion;
var
   letra : char;	(* letra actual *)
   i, j : 1..N;

begin
     (* rellenar la primera fila con la clave *)
     for i := 1 to N do
         mc[1,i] := clave[i];
     (* rellenar resto de filas *)
     (* inicializar recorrido intervalo de letras *)
     letra := 'a';
     for i := 2 to N do
         for j := 1 to N do begin
             while CarEnPalabra(clave, N, letra) or
                   (letra = 'j') or (letra = '') do
	                  letra := Succ(letra);
             mc[i,j] := letra;
             letra := Succ(letra);
         end;
end;

procedure PosEnTabla(m : MatrizCar; car : char; var pos : Posicion);
(* PRE:  car es una letra y se encuentra en la tabla *)
var
     i, j : 1..N;
begin
     i := 1;
     j := 1;
     while (m[i,j] <> car) do
           if j < N then j := j + 1
       	   else begin
                     i := i + 1;
                     j := 1
           end;
     pos.f := i;
     pos.c:= j;
end;

procedure Codificacion(par : ParLetras; var nuevoPar : ParLetras);
var
   p1, p2 : Posicion;
   fila, col : 1..N;

begin
     PosEnTabla(mc, par.p, p1);
     PosEnTabla(mc, par.s, p2);
     if p1.f = p2.f then begin
                              p1.c := p1.c mod N + 1;
			      p2.c := p2.c mod N + 1;
                              nuevoPar.p := mc[p1.f, p1.c];
			      nuevoPar.s := mc[p2.f, p2.c]
     end
     else if p1.c = p2.c then begin
                                   p1.f := p1.f mod N + 1;
				   p2.f := p2.f mod N + 1;
                                   nuevoPar.p := mc[p1.f, p1.c] ;
				   nuevoPar.s := mc[p2.f, p2.c]
     end
     else begin
               nuevoPar.p := mc[p1.f, p2.c];
	       nuevoPar.s := mc[p2.f, p1.c]
     end;
end;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 6.17. Cifrado PlayFair *****');
     writeln('*****');
     writeln;

     write('Introduzca la palabra clave de 5 letras: ');
     readln(clave);
     TratamientoInicial_MSC1(S);
     Cargar_fichero_MSC1(S,'dat6_17.txt');
     writeln;
     write('El texto original es: ');
     Comenzar_MSC1(S);
     while EA_MSC1(S) <> MSC1_MarcaFin do begin
           write(EA_MSC1(S));
           Avanzar_MSC1(S);
     end;
     CrearMatrizCodificacion;
     ComenzarPar;
     TratamientoInicial_MSC1(R);
     Arrancar_MSC1(R);
     while not FinPares do begin
           Codificacion(parActual, parCifrado);
	   Registrar_MSC1(R, parCifrado.p);
           Registrar_MSC1(R, parCifrado.s);
           AvanzarPar;
     end;
     Marcar_MSC1(R);
     writeln;
     writeln;
     write('El texto cifrado es: ');
     Comenzar_MSC1(R);
     while (EA_MSC1(R) <> MSC1_MarcaFin) do begin
           write(EA_MSC1(R));
           Avanzar_MSC1(R) ;
     end;
     writeln;
     writeln;
     write('Pulse enter para continuar');
     readln
end.


