program Algoritmo6_3;
(*
 * Algoritmo 6.3. Calculo de la frecuencia de aparicion de las letras mayusculas en un texto
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 6. Tablas
 * Fichero de entrada: datos6_3.txt
 *)

uses crt, unitmsc1;

type
    FrecuenciaLetras = array ['A'..'Z'] of integer;
var
   tf : FrecuenciaLetras;
   s : msc1;

procedure InicializarTablaFrecuencias (var t : FrecuenciaLetras);
(* Inicializacion de la tabla con ceros *)
(* POST:  t[c] = 0, c: 'A' <= c <= 'Z' *)

var
   c : 'A'..'Z';

begin
     for c := 'A' to 'Z' do
         t[c] := 0;
     end;

procedure EscribirTablaFrecuencias (t : FrecuenciaLetras);
(* POST: Se escriben los valores de la tabla t *)
var
   c : 'A'..'Z';

begin
     writeln;
     for c := 'A' to 'Z' do begin
         write('  *|*  ', c, ' : ', t[c]);
         if ((ord(c)-ord('A')+1) mod 6 = 0) then writeln;
     end;
     writeln
end;

function EsMayuscula (car : char) : Boolean;
(* POST:  Retorna Verdadero si y solo si car es una letra mayuscula *)

begin
     EsMayuscula := (car >= 'A') and (car <= 'Z');
end;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 6.3. Calculo de la frecuencia de aparicion de las *****');
     writeln('*****                letras mayusculas en un texto                *****');
     writeln('*****');
     writeln;
     TratamientoInicial_MSC1(s);
     Cargar_fichero_MSC1(s,'datos6_3.txt');
     Comenzar_MSC1(s);
     if EA_MSC1(s) = MSC1_MarcaFin then
        writeln('Secuencia vacia')
     else begin
               InicializarTablaFrecuencias(tf);
               write('La secuencia de entrada es: ');
   	       repeat
                     if EA_MSC1(s) = MSC1_MarcaFinLinea then writeln
                     else write(EA_MSC1(s));
	             if EsMayuscula(EA_MSC1(s)) then
                        tf[EA_MSC1(s)] := tf[EA_MSC1(s)] + 1;
        	     Avanzar_MSC1(s);
		     (* INV: tf almacena la frecuencia de aparicion de cada
                             letra mayuscula en Piz *)
     	       until EA_MSC1(s) = MSC1_MarcaFin;
               writeln;
	       EscribirTablaFrecuencias(tf);
     end;
     writeln;
     write('Pulse enter para continuar');
     readln
end.

