program Algoritmo7_13;
(*
 * Algoritmo 7.13. Accion recursiva que resuelve el problema de las torres de Hanoi
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 7. Disenyo recursivo
 *)

uses crt;

const
     MAX = 15;

type
    Estaca = 'A'..'C'; (* El tipo Estaca sera un rango de caracteres *)

var
   ndiscos : integer;

procedure Hanoi(n : integer; origen, intermedio, destino: Estaca);
   (* PRE  ...                la explicada en el texto *)
   (* POST  ...               la explicada en el texto *)
	   procedure mover(X, Y: Estaca);
	      (* PRE  ... 		 la explicada en el texto *)
	      (* POST  ... 		 la explicada en el texto *)
		 begin	(* de la accion mover *)
                        (*
                         * En nuestro caso la accion mover se limitara a
                         * mostrar por la salida el movimiento realizado.
                         * En general podria involucrar la modificacion del
                         * estado de las estacas, si quisieramos llevar cuenta
                         * del estado del juego en cada momento. Por esta
                         * razon los parametros de tipo Estaca de la accion
                         * Hanoi son de tipo dato-resultado.
                         *)
                         writeln('  mover disco de la estaca ', X, ' a la estaca ', Y)
                 end;
begin		(* de la accion Hanoi *)
     case n of
        1 : mover(origen, destino)
        else (* n > 1 *) begin
            Hanoi(n-1, origen, destino, intermedio);
            mover(origen, destino);
            Hanoi(n-1, intermedio, origen, destino)
        end
     end
end;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 7.13. Accion recursiva que resuelve el *****');
     writeln('*****                 problema de las torres de Hanoi  *****');
     writeln('*****');
     writeln;
     write('Numero de discos (maximo ', MAX, '): ');
     readln(ndiscos);
     writeln;
     Hanoi(ndiscos, 'A', 'B', 'C');
     writeln;
     write('Pulse enter para continuar');
     readln
end.

