program Algoritmo7_5;
(*
 * Algoritmo 7.5. Funcion producto escalar iterativa, equivalente a la del Algoritmo 7.4
 * Titulo del libro: Una introduccion a la programacion.
 *                   Un enfoque algoritmico
 * Autores del libro: Jesus J. Garcia Molina
 *                    Francisco J. Montoya Dato
 *                    Jose L. Fernandez Aleman
 *                    Maria J. Majado Rosales
 * Fecha: 1/9/2005
 * Capitulo 7. Disenyo recursivo
 *)

uses crt;

const
     MAX = 10;

type
    Vector = array [1..MAX] of real;

var
   vv1, vv2 : Vector;
   n, i : integer;

function peii (v1, v2 : Vector; a, b : integer; c : real) : real;
	(* PRE 1 <= a <= b <= MAX, y v1 y v2 tienen valores significativos en [a, b] *)
	(* POST  pei (v1, v2, a, b, c) = c + sumatorio desde i = a hasta b de v1[i] * v2[i] *)
var
	a_loc : integer;	(* corresponde al parametro a *)
	c_loc : real;		(* corresponde al parametro c *)
				(* el parametro b no varia, no necesita copia local *)

begin
	a_loc := a; c_loc := c;
	while a_loc < b do begin
		c_loc :=  c_loc + v1[a_loc] * v2[a_loc];
		a_loc := a_loc + 1
	end;
	peii := c_loc + v1[a_loc] * v2[a_loc]
end;

begin
     clrscr;
     writeln;
     writeln('*****');
     writeln('***** Algoritmo 7.5. Funcion producto escalar iterativa, *****');
     writeln('*****                equivalente a la del Algoritmo 7.4  *****');
     writeln('*****');
     writeln;
     write('Introduzca el numero de elementos de los vectores (> 0) y (<=',MAX,'): ');
     readln(n);
     writeln;
     writeln('Primer vector');
     for i := 1 to n do begin
        write('   Componente ', i, ': ');
        readln(vv1[i]);
     end;
     writeln;
     writeln('Segundo vector');
     for i := 1 to n do begin
        write('   Componente ', i, ': ');
        readln(vv2[i]);
     end;
     writeln;
     writeln('El producto escalar de los vectores es: ', peii (vv1, vv2, 1, n, 0):1:2);
     writeln;
     write('Pulse enter para continuar');
     readln;
end.

